#include <cstring>
#include <cstdio>
#include <queue>

using namespace std;

const int INF = 1e9;
const int MAXN = 1e6;
int g[MAXN], nxt[MAXN], dist[MAXN], to[MAXN], eid;
int n, m, k, p;
int d[MAXN], d1[MAXN], cnt[MAXN];
int ans;
bool inq[MAXN];

void addedge(int u, int v, int w)
{
	to[eid] = v;
	dist[eid] = w;
	nxt[eid] = g[u];
	g[u] = eid++;
}

bool spfa(int s)
{
	queue<int> q;
	q.push(s);
	inq[s] = true;
	for(int i = 1; i <= n; ++i)
		d[i] = INF;
	d[s] = 0;
	while(!q.empty())
	{
		int u = q.front();
		q.pop();
		inq[u] = false;
		for(int i = g[u]; i+1; i = nxt[i])
		{
			if(d[to[i]] >= d[u] + dist[i])
			{
				d[to[i]] = d[u] + dist[i];
				if(!inq[to[i]])
				{
					q.push(to[i]);
					inq[to[i]] = true;
					if(++cnt[to[i]] > n)
						return false;
				}
			}
		}
	}
	return true;
}

void sol(int x, int dep)
{
	if(dep > d[x]+k)
		return ;
	if(x == n && dep <= d[n]+k)
	{
		ans++;
		ans %= p;
	}
	for(int i = g[x]; i+1; i = nxt[i])
		sol(to[i], dep+dist[i]);
}

void init()
{
	memset(cnt, 0, sizeof(cnt));
	memset(g, -1, sizeof(g));
	eid = 0;
}

int main()
{
	freopen("park.in", "r", stdin);
	freopen("park.out", "w", stdout);
	int T;
	scanf("%d", &T);
	while(T--)
	{
		scanf("%d%d%d%d", &n, &m, &k, &p);
		init();
		for(int i = 0; i < m; ++i)
		{
			int x, y, z;
			scanf("%d%d%d", &x, &y, &z);
			addedge(x, y, z);
		}
		if(!spfa(1))
		{
			printf("-1\n");
			continue;
		}
		sol(1, 0);
		printf("%d\n", ans);
	}
	return 0;
}
