#include <iostream>
#include <algorithm>
#include <queue>
#include <cstdio>
#include <cstring>

const int maxn = 100010;
const int maxm = 200010;

using namespace std;

struct Edge
{
	int to, wi, nxt;
};

int T;
int N, M, K, P;
int u, v, w;
int cnt_edge = 0;
int head[maxn];
Edge e[maxm];

void add_edge(int u, int v, int w)
{
	e[++cnt_edge].to = v;
	e[cnt_edge].wi = w;
	e[cnt_edge].nxt = head[u];
	head[u] = cnt_edge;
}

int d[maxn];
int num[maxn];
bool inq[maxn];
void spfa(int s)
{
	queue<int> q;
	d[s] = 0;
	num[s] = 1 % P;
	q.push(s);
	inq[s] = true;
	while (!q.empty())
	{
		int u = q.front();
		q.pop();
		inq[u] = false;
		for (int i = head[u]; i; i = e[i].nxt)
		{
			if (d[e[i].to] > d[u] + e[i].wi)
			{
				d[e[i].to] = d[u] + e[i].wi;
				num[e[i].to] = num[u] % P;
				if (!inq[e[i].to])
				{
					q.push(e[i].to);
					inq[e[i].to] = true;
				}
			}
			else if (d[e[i].to] == d[u] + e[i].wi)
			{
				num[e[i].to] = (num[e[i].to] + num[u]) % P;
				if (!inq[e[i].to])
				{
					q.push(e[i].to);
					inq[e[i].to] = true;
				}
			}
		}
	}
}

int main()
{
    freopen("park.in", "r", stdin);
    freopen("park.out", "w", stdout);
    scanf("%d", &T);
    while (T--)
    {
    	memset(head, 0, sizeof(head));
    	scanf("%d%d%d%d", &N, &M, &K, &P);
    	for (int i = 1; i <= M; i++)
    	{
    		scanf("%d%d%d", &u, &v, &w);
    		add_edge(u, v, w);
    	}
    	memset(d, 0x7f, sizeof(d));
    	memset(num, 0, sizeof(num));
    	memset(inq, 0, sizeof(inq));
    	spfa(1);
    	if (K == 0)
    		printf("%d\n", num[N] % P);
    	else
    		printf("%d\n", (num[N] * 2 + K) % P);
    }
    fclose(stdin);
    fclose(stdout);
    return 0;
}

